<?php
/**
 * FLEX_GUTENBERG_THEME Theme Customizer
 *
 * @package FLEX_GUTENBERG_THEME
 */

/**
 * Add postMessage support for site title and description for the Theme Customizer.
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function flex_gutenberg_theme_customize_register($wp_customize)
{
	$wp_customize->get_setting('blogname')->transport         = 'postMessage';
	$wp_customize->get_setting('blogdescription')->transport  = 'postMessage';
	$wp_customize->get_setting('header_textcolor')->transport = 'postMessage';

	if (isset($wp_customize->selective_refresh)) {
		$wp_customize->selective_refresh->add_partial(
			'blogname',
			array(
				'selector'        => '.site-title a',
				'render_callback' => 'flex_gutenberg_theme_customize_partial_blogname',
			)
		);
		$wp_customize->selective_refresh->add_partial(
			'blogdescription',
			array(
				'selector'        => '.site-description',
				'render_callback' => 'flex_gutenberg_theme_customize_partial_blogdescription',
			)
		);
	}
}
add_action('customize_register', 'flex_gutenberg_theme_customize_register');

/**
 * Render the site title for the selective refresh partial.
 *
 * @return void
 */
function flex_gutenberg_theme_customize_partial_blogname()
{
	bloginfo('name');
}

/**
 * Render the site tagline for the selective refresh partial.
 *
 * @return void
 */
function flex_gutenberg_theme_customize_partial_blogdescription()
{
	bloginfo('description');
}

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function flex_gutenberg_theme_customize_preview_js()
{
	wp_enqueue_script('flex_gutenberg_theme-customizer', get_template_directory_uri() . '/js/customizer.js', array('customize-preview'), FLEX_GUTENBERG_THEME_VERSION, TRUE);
}
add_action('customize_preview_init', 'flex_gutenberg_theme_customize_preview_js');
